//+------------------------------------------------------------------+
//|                                                       FooLib.mqh |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict

class FooAbstract
{
protected:
   FooAbstract() {}   //   protected
public:
   ~FooAbstract() {}
   //   
   virtual void Say(void) {}
   //      /
   virtual void SetText(string) { }
   virtual string GetText() { return "";} 
};

#import "Foo/FooLib.ex4"
FooAbstract *FooCoreInstance();
#import

class Foo:public FooAbstract
{
private:
   FooAbstract *core;   //  
protected:
public: 
   Foo() { core = FooCoreInstance() ; }
   ~Foo() { delete core; }
   //    core  
   //   
   virtual void Say(void) { core.Say(); }
   //      /
   virtual void SetText(string s ) { core.SetText(s);}
   virtual string GetText() { return core.GetText(); }
};

